#include "catch.hpp"

#include <map>
#include "fact.h"

SCENARIO("computing factorials")
{
    GIVEN("input is zero") {
        REQUIRE( factorial(0UL) == 1UL );
    }

    GIVEN("input is non-zero") {
        using ull_t = unsigned long long;
        std::map<ull_t, ull_t> table = {
            {  1UL,       1UL },
            {  2UL,       2UL },
            {  5UL,     120UL },
            { 10UL, 3628800UL },
        };

        for (const auto& kv : table) {
            REQUIRE( factorial(kv.first) == kv.second );
        }
    }
}
